
_ADC_START:

;ADC_ATMEGA328P.c,6 :: 		void ADC_START(void) {
;ADC_ATMEGA328P.c,9 :: 		ADMUX &=~ (1<<ADLAR);
	LDS        R16, ADMUX+0
	ANDI       R16, 223
	STS        ADMUX+0, R16
;ADC_ATMEGA328P.c,12 :: 		ADMUX |=  (1<<REFS0);
	ORI        R16, 64
	STS        ADMUX+0, R16
;ADC_ATMEGA328P.c,13 :: 		ADMUX &=~ (1<<REFS1);
	ANDI       R16, 127
	STS        ADMUX+0, R16
;ADC_ATMEGA328P.c,16 :: 		ADCSRA |= (1<<ADPS0);
	LDS        R16, ADCSRA+0
	ORI        R16, 1
	STS        ADCSRA+0, R16
;ADC_ATMEGA328P.c,17 :: 		ADCSRA |= (1<<ADPS1);
	LDS        R27, ADCSRA+0
	SBR        R27, 2
	STS        ADCSRA+0, R27
;ADC_ATMEGA328P.c,18 :: 		ADCSRA |= (1<<ADPS2);
	LDS        R16, ADCSRA+0
	ORI        R16, 4
	STS        ADCSRA+0, R16
;ADC_ATMEGA328P.c,19 :: 		}
L_end_ADC_START:
	RET
; end of _ADC_START

_ADC_measuring:

;ADC_ATMEGA328P.c,21 :: 		unsigned int ADC_measuring(short int canal)
;ADC_ATMEGA328P.c,22 :: 		{       unsigned int valor =0;
;ADC_ATMEGA328P.c,25 :: 		ADMUX &=~  0x0F;
	LDS        R16, ADMUX+0
	ANDI       R16, 240
	STS        ADMUX+0, R16
;ADC_ATMEGA328P.c,26 :: 		ADMUX |=  canal;
	OR         R16, R2
	STS        ADMUX+0, R16
;ADC_ATMEGA328P.c,29 :: 		ADCSRA |= (1<<ADEN);
	LDS        R27, ADCSRA+0
	SBR        R27, 128
	STS        ADCSRA+0, R27
;ADC_ATMEGA328P.c,30 :: 		delay_us(10);        // wait a moment for the stability.
	LDI        R16, 53
L_ADC_measuring0:
	DEC        R16
	BRNE       L_ADC_measuring0
	NOP
;ADC_ATMEGA328P.c,33 :: 		ADCSRA |= (1<<ADSC);
	LDS        R16, ADCSRA+0
	ORI        R16, 64
	STS        ADCSRA+0, R16
;ADC_ATMEGA328P.c,36 :: 		while( !(ADCSRA & (1<<ADIF)) );
L_ADC_measuring2:
	LDS        R16, ADCSRA+0
	SBRC       R16, 4
	JMP        L_ADC_measuring3
	JMP        L_ADC_measuring2
L_ADC_measuring3:
;ADC_ATMEGA328P.c,37 :: 		ADCSRA |= (1<<ADIF);        // Reset the flag.
	LDS        R16, ADCSRA+0
	ORI        R16, 16
	STS        ADCSRA+0, R16
;ADC_ATMEGA328P.c,40 :: 		ADCSRA &=~ (1<<ADEN);
	LDS        R16, ADCSRA+0
	ANDI       R16, 127
	STS        ADCSRA+0, R16
;ADC_ATMEGA328P.c,41 :: 		valor = ADCL;      //Merge the adcl register with adch register and
; valor start address is: 18 (R18)
	LDS        R18, ADCL+0
	LDI        R19, 0
;ADC_ATMEGA328P.c,42 :: 		valor |= ADCH<<8;   //after that send the result.
	LDS        R16, ADCH+0
	MOV        R17, R16
	CLR        R16
	OR         R16, R18
	OR         R17, R19
; valor end address is: 18 (R18)
;ADC_ATMEGA328P.c,43 :: 		return valor;
;ADC_ATMEGA328P.c,44 :: 		}
L_end_ADC_measuring:
	RET
; end of _ADC_measuring

ADC_ATMEGA328P____?ag:

L_end_ADC_ATMEGA328P___?ag:
	RET
; end of ADC_ATMEGA328P____?ag
