
_PWM_init:

;PWM.c,7 :: 		void PWM_init(long freq)
;PWM.c,10 :: 		TCCR1A &=~ (1<<WGM10);
	LDS        R16, TCCR1A+0
	ANDI       R16, 254
	STS        TCCR1A+0, R16
;PWM.c,11 :: 		TCCR1A |=  (1<<WGM11);
	ORI        R16, 2
	STS        TCCR1A+0, R16
;PWM.c,12 :: 		TCCR1B |=  (1<<WGM12);
	LDS        R16, TCCR1B+0
	ORI        R16, 8
	STS        TCCR1B+0, R16
;PWM.c,13 :: 		TCCR1B |=  (1<<WGM13);
	ORI        R16, 16
	STS        TCCR1B+0, R16
;PWM.c,16 :: 		_freq = freq;
	STS        __freq+0, R2
	STS        __freq+1, R3
	STS        __freq+2, R4
	STS        __freq+3, R5
;PWM.c,18 :: 		ICR1L = (F_CPU/1024/_freq) - 1;
	MOVW       R20, R2
	MOVW       R22, R4
	LDI        R16, 9
	LDI        R17, 61
	LDI        R18, 0
	LDI        R19, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	SUBI       R16, 1
	STS        ICR1L+0, R16
;PWM.c,19 :: 		ICR1H |= ((F_CPU/1024/_freq) - 1)>>8;
	LDS        R20, __freq+0
	LDS        R21, __freq+1
	LDS        R22, __freq+2
	LDS        R23, __freq+3
	LDI        R16, 9
	LDI        R17, 61
	LDI        R18, 0
	LDI        R19, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	SUBI       R16, 1
	SBCI       R17, 0
	SBCI       R18, 0
	SBCI       R19, 0
	MOV        R20, R17
	MOV        R21, R18
	MOV        R22, R19
	LDI        R23, 0
	SBRC       R22, 7
	LDI        R23, 255
	LDS        R16, ICR1H+0
	OR         R16, R20
	STS        ICR1H+0, R16
;PWM.c,20 :: 		}
L_end_PWM_init:
	RET
; end of _PWM_init

_PWM_on:

;PWM.c,21 :: 		void PWM_on()
;PWM.c,23 :: 		TCNT1L = 0x0000;
	LDI        R27, 0
	STS        TCNT1L+0, R27
;PWM.c,25 :: 		TCCR1B |=  (1<<CS10);
	LDS        R16, TCCR1B+0
	ORI        R16, 1
	STS        TCCR1B+0, R16
;PWM.c,26 :: 		TCCR1B &=~ (1<<CS11);
	ANDI       R16, 253
	STS        TCCR1B+0, R16
;PWM.c,27 :: 		TCCR1B |=  (1<<CS12);
	ORI        R16, 4
	STS        TCCR1B+0, R16
;PWM.c,28 :: 		}
L_end_PWM_on:
	RET
; end of _PWM_on

_PWM_off:

;PWM.c,30 :: 		void PWM_off()
;PWM.c,33 :: 		TCCR1B &=~ (1<<CS10);
	LDS        R16, TCCR1B+0
	ANDI       R16, 254
	STS        TCCR1B+0, R16
;PWM.c,34 :: 		TCCR1B &=~ (1<<CS11);
	ANDI       R16, 253
	STS        TCCR1B+0, R16
;PWM.c,35 :: 		TCCR1B &=~ (1<<CS12);
	ANDI       R16, 251
	STS        TCCR1B+0, R16
;PWM.c,36 :: 		}
L_end_PWM_off:
	RET
; end of _PWM_off

_PWM_Write_duty:

;PWM.c,38 :: 		void PWM_Write_duty(unsigned int duty, char channel, unsigned int resolution)
;PWM.c,40 :: 		unsigned int reg=0;
;PWM.c,42 :: 		if(channel == 'A' ) {
	LDI        R27, 65
	CP         R4, R27
	BREQ       L__PWM_Write_duty34
	JMP        L_PWM_Write_duty0
L__PWM_Write_duty34:
;PWM.c,44 :: 		DDRB |= (1<<DDB1);
	IN         R27, DDRB+0
	SBR        R27, 2
	OUT        DDRB+0, R27
;PWM.c,47 :: 		TCCR1A &=~ (1<<COM1A0);
	LDS        R16, TCCR1A+0
	ANDI       R16, 191
	STS        TCCR1A+0, R16
;PWM.c,48 :: 		TCCR1A |=  (1<<COM1A1);
	ORI        R16, 128
	STS        TCCR1A+0, R16
;PWM.c,50 :: 		reg = (((F_CPU/1024/_freq) - 1)*duty)/resolution;
	PUSH       R6
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	LDS        R20, __freq+0
	LDS        R21, __freq+1
	LDS        R22, __freq+2
	LDS        R23, __freq+3
	LDI        R16, 9
	LDI        R17, 61
	LDI        R18, 0
	LDI        R19, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	POP        R2
	POP        R3
	POP        R4
	POP        R5
	POP        R6
	SUBI       R16, 1
	SBCI       R17, 0
	SBCI       R18, 0
	SBCI       R19, 0
	MOVW       R20, R2
	LDI        R22, 0
	MOV        R23, R22
	CALL       _HWMul_32x32+0
	PUSH       R6
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	MOV        R20, R5
	MOV        R21, R6
	LDI        R22, 0
	MOV        R23, R22
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	POP        R2
	POP        R3
	POP        R4
	POP        R5
	POP        R6
;PWM.c,51 :: 		OCR1AL = reg;
	STS        OCR1AL+0, R16
;PWM.c,52 :: 		OCR1AH |= reg >>8;
	MOV        R20, R17
	LDI        R21, 0
	LDS        R16, OCR1AH+0
	OR         R16, R20
	STS        OCR1AH+0, R16
;PWM.c,53 :: 		if((duty == resolution) && (aux==1)) PWM_off(), PORTB1_bit=1, aux=2;
	CP         R2, R5
	CPC        R3, R6
	BREQ       L__PWM_Write_duty35
	JMP        L__PWM_Write_duty23
L__PWM_Write_duty35:
	LDS        R16, _aux+0
	CPI        R16, 1
	BREQ       L__PWM_Write_duty36
	JMP        L__PWM_Write_duty22
L__PWM_Write_duty36:
L__PWM_Write_duty21:
	CALL       _PWM_off+0
	IN         R27, PORTB1_bit+0
	SBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
	LDI        R27, 2
	STS        _aux+0, R27
L__PWM_Write_duty23:
L__PWM_Write_duty22:
;PWM.c,54 :: 		if(duty <resolution) aux=0;
	CP         R2, R5
	CPC        R3, R6
	BRLO       L__PWM_Write_duty37
	JMP        L_PWM_Write_duty4
L__PWM_Write_duty37:
	LDI        R27, 0
	STS        _aux+0, R27
L_PWM_Write_duty4:
;PWM.c,55 :: 		if(duty ==0) PWM_off(),  PORTB1_bit=0, aux=0;
	LDI        R27, 0
	CP         R3, R27
	BRNE       L__PWM_Write_duty38
	LDI        R27, 0
	CP         R2, R27
L__PWM_Write_duty38:
	BREQ       L__PWM_Write_duty39
	JMP        L_PWM_Write_duty5
L__PWM_Write_duty39:
	CALL       _PWM_off+0
	IN         R27, PORTB1_bit+0
	CBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
	LDI        R27, 0
	STS        _aux+0, R27
L_PWM_Write_duty5:
;PWM.c,56 :: 		if((duty>0) && (aux==0)) PWM_on(), aux=1;
	LDI        R16, 0
	LDI        R17, 0
	CP         R16, R2
	CPC        R17, R3
	BRLO       L__PWM_Write_duty40
	JMP        L__PWM_Write_duty25
L__PWM_Write_duty40:
	LDS        R16, _aux+0
	CPI        R16, 0
	BREQ       L__PWM_Write_duty41
	JMP        L__PWM_Write_duty24
L__PWM_Write_duty41:
L__PWM_Write_duty20:
	CALL       _PWM_on+0
	LDI        R27, 1
	STS        _aux+0, R27
L__PWM_Write_duty25:
L__PWM_Write_duty24:
;PWM.c,57 :: 		}
L_PWM_Write_duty0:
;PWM.c,59 :: 		if(channel == 'B' ) {
	LDI        R27, 66
	CP         R4, R27
	BREQ       L__PWM_Write_duty42
	JMP        L_PWM_Write_duty9
L__PWM_Write_duty42:
;PWM.c,61 :: 		DDRB |= (1<<DDB2);
	IN         R16, DDRB+0
	ORI        R16, 4
	OUT        DDRB+0, R16
;PWM.c,64 :: 		TCCR1A &=~ (1<<COM1B0);
	LDS        R16, TCCR1A+0
	ANDI       R16, 239
	STS        TCCR1A+0, R16
;PWM.c,65 :: 		TCCR1A |=  (1<<COM1B1);
	ORI        R16, 32
	STS        TCCR1A+0, R16
;PWM.c,67 :: 		reg = (((F_CPU/1024/_freq) - 1)*duty)/resolution;
	PUSH       R6
	PUSH       R5
	PUSH       R3
	PUSH       R2
	LDS        R20, __freq+0
	LDS        R21, __freq+1
	LDS        R22, __freq+2
	LDS        R23, __freq+3
	LDI        R16, 9
	LDI        R17, 61
	LDI        R18, 0
	LDI        R19, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	POP        R2
	POP        R3
	POP        R5
	POP        R6
	SUBI       R16, 1
	SBCI       R17, 0
	SBCI       R18, 0
	SBCI       R19, 0
	MOVW       R20, R2
	LDI        R22, 0
	MOV        R23, R22
	CALL       _HWMul_32x32+0
	PUSH       R6
	PUSH       R5
	PUSH       R3
	PUSH       R2
	MOV        R20, R5
	MOV        R21, R6
	LDI        R22, 0
	MOV        R23, R22
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	POP        R2
	POP        R3
	POP        R5
	POP        R6
;PWM.c,68 :: 		OCR1BL = reg;
	STS        OCR1BL+0, R16
;PWM.c,69 :: 		OCR1BH |= reg>>8;
	MOV        R20, R17
	LDI        R21, 0
	LDS        R16, OCR1BH+0
	OR         R16, R20
	STS        OCR1BH+0, R16
;PWM.c,70 :: 		if((duty == resolution) && (aux==1)) PWM_off(), PORTB2_bit=1, aux=2;
	CP         R2, R5
	CPC        R3, R6
	BREQ       L__PWM_Write_duty43
	JMP        L__PWM_Write_duty27
L__PWM_Write_duty43:
	LDS        R16, _aux+0
	CPI        R16, 1
	BREQ       L__PWM_Write_duty44
	JMP        L__PWM_Write_duty26
L__PWM_Write_duty44:
L__PWM_Write_duty19:
	CALL       _PWM_off+0
	IN         R27, PORTB2_bit+0
	SBR        R27, BitMask(PORTB2_bit+0)
	OUT        PORTB2_bit+0, R27
	LDI        R27, 2
	STS        _aux+0, R27
L__PWM_Write_duty27:
L__PWM_Write_duty26:
;PWM.c,71 :: 		if(duty <resolution) aux=0;
	CP         R2, R5
	CPC        R3, R6
	BRLO       L__PWM_Write_duty45
	JMP        L_PWM_Write_duty13
L__PWM_Write_duty45:
	LDI        R27, 0
	STS        _aux+0, R27
L_PWM_Write_duty13:
;PWM.c,72 :: 		if(duty ==0) PWM_off(),  PORTB2_bit=0, aux=0;
	LDI        R27, 0
	CP         R3, R27
	BRNE       L__PWM_Write_duty46
	LDI        R27, 0
	CP         R2, R27
L__PWM_Write_duty46:
	BREQ       L__PWM_Write_duty47
	JMP        L_PWM_Write_duty14
L__PWM_Write_duty47:
	CALL       _PWM_off+0
	IN         R27, PORTB2_bit+0
	CBR        R27, BitMask(PORTB2_bit+0)
	OUT        PORTB2_bit+0, R27
	LDI        R27, 0
	STS        _aux+0, R27
L_PWM_Write_duty14:
;PWM.c,73 :: 		if((duty>0) && (aux==0)) PWM_on(), aux=1;
	LDI        R16, 0
	LDI        R17, 0
	CP         R16, R2
	CPC        R17, R3
	BRLO       L__PWM_Write_duty48
	JMP        L__PWM_Write_duty29
L__PWM_Write_duty48:
	LDS        R16, _aux+0
	CPI        R16, 0
	BREQ       L__PWM_Write_duty49
	JMP        L__PWM_Write_duty28
L__PWM_Write_duty49:
L__PWM_Write_duty18:
	CALL       _PWM_on+0
	LDI        R27, 1
	STS        _aux+0, R27
L__PWM_Write_duty29:
L__PWM_Write_duty28:
;PWM.c,74 :: 		}
L_PWM_Write_duty9:
;PWM.c,75 :: 		}
L_end_PWM_Write_duty:
	RET
; end of _PWM_Write_duty

PWM____?ag:

L_end_PWM___?ag:
	RET
; end of PWM____?ag
