

#include "ADC_ATMEGA328P.h"
#include "built_in.h"
          
void ADC_START(void) {

   // Initialize the ADC.
   ADMUX &=~ (1<<ADLAR);

 //  Reference voltage  = AVCC.
   ADMUX |=  (1<<REFS0);
   ADMUX &=~ (1<<REFS1);

// Frequency divisor = 128 -> 16000/128 = 125 KHz.
    ADCSRA |= (1<<ADPS0);
    ADCSRA |= (1<<ADPS1);
    ADCSRA |= (1<<ADPS2);
}

unsigned int ADC_measuring(short int canal)
{       unsigned int valor =0;

        // ADC channel selection.
        ADMUX &=~  0x0F;
        ADMUX |=  canal;

        // Turn on the ADC.
        ADCSRA |= (1<<ADEN);
        delay_us(10);        // wait a moment for the stability.

        // Send the sampling.
        ADCSRA |= (1<<ADSC);

        // Wait for the sampling and after that read the flag.
        while( !(ADCSRA & (1<<ADIF)) );
        ADCSRA |= (1<<ADIF);        // Reset the flag.

        // Turn off the ADC.
        ADCSRA &=~ (1<<ADEN);
      valor = ADCL;      //Merge the adcl register with adch register and
      valor |= ADCH<<8;   //after that send the result.
   return valor;
}