#line 1 "C:/Users/Usuario/Documents/MikroC_pro_avr/PWM/PWM_without_MikroC_library/PWM.c"
#line 1 "c:/users/usuario/documents/mikroc_pro_avr/pwm/pwm_without_mikroc_library/pwm.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for avr/include/built_in.h"
#line 8 "c:/users/usuario/documents/mikroc_pro_avr/pwm/pwm_without_mikroc_library/pwm.h"
 void PWM_init(long freq);
 void PWM_on();
 void PWM_off();
 void PWM_Write_duty(unsigned int duty, char channel, unsigned int resolution);
#line 4 "C:/Users/Usuario/Documents/MikroC_pro_avr/PWM/PWM_without_MikroC_library/PWM.c"
 long _freq = 0;
 char aux = 0;

void PWM_init(long freq)
{

 TCCR1A &=~ (1<<WGM10);
 TCCR1A |= (1<<WGM11);
 TCCR1B |= (1<<WGM12);
 TCCR1B |= (1<<WGM13);


 _freq = freq;

 ICR1L = ( 16000000 /1024/_freq) - 1;
 ICR1H |= (( 16000000 /1024/_freq) - 1)>>8;
}
void PWM_on()
{
 TCNT1L = 0x0000;

 TCCR1B |= (1<<CS10);
 TCCR1B &=~ (1<<CS11);
 TCCR1B |= (1<<CS12);
}

void PWM_off()
{

 TCCR1B &=~ (1<<CS10);
 TCCR1B &=~ (1<<CS11);
 TCCR1B &=~ (1<<CS12);
}

void PWM_Write_duty(unsigned int duty, char channel, unsigned int resolution)
{
 unsigned int reg=0;

 if(channel == 'A' ) {

 DDRB |= (1<<DDB1);


 TCCR1A &=~ (1<<COM1A0);
 TCCR1A |= (1<<COM1A1);

 reg = ((( 16000000 /1024/_freq) - 1)*duty)/resolution;
 OCR1AL = reg;
 OCR1AH |= reg >>8;
 if((duty == resolution) && (aux==1)) PWM_off(), PORTB1_bit=1, aux=2;
 if(duty <resolution) aux=0;
 if(duty ==0) PWM_off(), PORTB1_bit=0, aux=0;
 if((duty>0) && (aux==0)) PWM_on(), aux=1;
 }

 if(channel == 'B' ) {

 DDRB |= (1<<DDB2);


 TCCR1A &=~ (1<<COM1B0);
 TCCR1A |= (1<<COM1B1);

 reg = ((( 16000000 /1024/_freq) - 1)*duty)/resolution;
 OCR1BL = reg;
 OCR1BH |= reg>>8;
 if((duty == resolution) && (aux==1)) PWM_off(), PORTB2_bit=1, aux=2;
 if(duty <resolution) aux=0;
 if(duty ==0) PWM_off(), PORTB2_bit=0, aux=0;
 if((duty>0) && (aux==0)) PWM_on(), aux=1;
 }
}
